var DATA_CHANNEL_NAME = "Mergely Channel";
var MAX_COMPARE_SIZE = 1000000;

var win;
var web;
var fmDiffCompare
var DiffFormOpenDialog;
var edCurrentFile;
var edOtherFile;
var lbFiles;
var lefttext = "";
var leftfileind = -1;
var righttext = "";
var rightfileind = -1;
var document_names[0];
var document_originals[0];

function LoadBrowser(LeftReadOnly, RightReadOnly) {
  var anchor = "";
  if (LeftReadOnly) {
      anchor = anchor + "lro,";
  }
  if (RightReadOnly) {
      anchor = anchor + "rro,";
  }

  if (win == null) {
     win = new TForm(WeBuilder);
     win.width = Round(Screen.Width * 0.75);
     win.Height = Round(Screen.Height * 0.8);
     win.Caption = "Merge View";
     web = Script.CreateScriptableWebKit(win, Script.GetPath + "win.html#" + anchor, "");
     web.Subscribe(DATA_CHANNEL_NAME, &OnWebkitData);
     web.OnConsoleMessage = &OnWebkitConsoleMessage;
     Web.OnLoadEnd = &OnWebkitLoadEnd;
     web.Webkit.Top = 0;
     web.Webkit.Left = 0;
     web.Webkit.Width = win.ClientWidth;
     web.Webkit.Height = win.ClientHeight;
     web.Webkit.Anchors = akLeft || akRight || akTop || akBottom;
     win.Show;
  } else {
    web.Webkit.Load("about:blank");
    web.Webkit.Load(Script.GetPath + "win.html#" + anchor);
    win.Show;
  }
}

function DefAdjust(x) {
    return Round(Script.DpiScale * x);
}

function DiffFormBrowseClick(Sender) {
  if (DiffFormOpenDialog.Execute()) {
    lbFiles.Items.Insert(0, DiffFormOpenDialog.FileName); //opens file
    lbFiles.ItemIndex = 0;
    edOtherFile.Text = lbFiles.Items[0];
  }
}

function DiffFormFilesClick(Sender) {
  if (lbFiles.ItemIndex >= 0) {
    edOtherFile.Text = lbFiles.Items[lbFiles.ItemIndex];
  }
}

function DiffFormFilesDblClick(Sender) {
  if (edOtherFile.Text == "") {
    edOtherFile.SetFocus();
    fmDiffCompare.ModalResult = mrNone;
  } else {
    fmDiffCompare.ModalResult = mrOK;
  }
}

function DiffFormBtnOkClick(Sender) {
  DiffFormFilesDblClick(Sender);
}

function CreateDiffForm() {
  fmDiffCompare = TForm.Create(WeBuilder);
  fmDiffCompare.BorderIcons = biSystemMenu;
  fmDiffCompare.Caption = "Diff Compare";
  fmDiffCompare.ClientHeight = DefAdjust(286);
  fmDiffCompare.ClientWidth = DefAdjust(598);
  fmDiffCompare.Color = clBtnFace;
  fmDiffCompare.Font.Name = WeBuilder.Font.Name;
  fmDiffCompare.Font.Size = WeBuilder.Font.Size;
  fmDiffCompare.Position = poScreenCenter;

  var lblPath = TLabel.Create(fmDiffCompare);
  lblPath.Parent = fmDiffCompare;
  lblPath.Left = DefAdjust(16);
  lblPath.Top = DefAdjust(52);
  lblPath.Width = DefAdjust(54);
  lblPath.Height = DefAdjust(15);
  lblPath.Caption = "Other File:";

  var Label1 = TLabel.Create(fmDiffCompare);
  Label1.Parent = fmDiffCompare;
  Label1.Left = DefAdjust(16);
  Label1.Top = DefAdjust(20);
  Label1.Width = DefAdjust(64);
  Label1.Height = DefAdjust(15);
  Label1.Caption = "Current File:";

  var btnOK = TButton.Create(fmDiffCompare);
  btnOK.Parent = fmDiffCompare;
  btnOK.Left = DefAdjust(416);
  btnOK.Top = DefAdjust(248);
  btnOK.Width = DefAdjust(81);
  btnOK.Height = DefAdjust(25);
  btnOK.Anchors = akRight || akBottom;
  btnOK.Caption = "OK";
  btnOK.Default = True;
  btnOK.OnClick = &DiffFormBtnOkClick;
  btnOK.TabOrder = 3;

  var btnCancel = TButton.Create(fmDiffCompare);
  btnCancel.Parent = fmDiffCompare;
  btnCancel.Left = DefAdjust(504);
  btnCancel.Top = DefAdjust(248);
  btnCancel.Width = DefAdjust(81);
  btnCancel.Height = DefAdjust(25);
  btnCancel.Anchors = akRight || akBottom;
  btnCancel.Cancel = True;
  btnCancel.Caption = "Cancel";
  btnCancel.ModalResult = 2;
  btnCancel.TabOrder = 4;

  var btnBrowse = TButton.Create(fmDiffCompare);
  btnBrowse.Parent = fmDiffCompare;
  btnBrowse.Left = DefAdjust(488);
  btnBrowse.Top = DefAdjust(47);
  btnBrowse.Width = DefAdjust(97);
  btnBrowse.Height = DefAdjust(25);
  btnBrowse.Anchors = akTop || akRight;
  btnBrowse.Caption = "Browse...";
  btnBrowse.TabOrder = 1;
  btnBrowse.OnClick = &DiffFormBrowseClick;

  lbFiles = TListBox.Create(fmDiffCompare);
  lbFiles.Parent = fmDiffCompare;
  lbFiles.Left = DefAdjust(96);
  lbFiles.Top = DefAdjust(80);
  lbFiles.Width = DefAdjust(385);
  lbFiles.Height = DefAdjust(145);
  lbFiles.Style = lbOwnerDrawFixed;
  lbFiles.Anchors = akLeft || akTop || akRight || akBottom;
  lbFiles.ItemHeight = DefAdjust(15);
  lbFiles.TabOrder = 2;
  lbFiles.OnClick = &DiffFormFilesClick;
  lbFiles.OnDblClick = &DiffFormFilesDblClick;

  edCurrentFile = TEdit.Create(fmDiffCompare);
  edCurrentFile.Parent = fmDiffCompare;
  edCurrentFile.Left = DefAdjust(96);
  edCurrentFile.Top = DefAdjust(16);
  edCurrentFile.Width = DefAdjust(385);
  edCurrentFile.Height = DefAdjust(21);
  edCurrentFile.Anchors = akLeft || akTop || akRight;
  edCurrentFile.Color = clBtnFace;
  edCurrentFile.Font.Color = clGrayText;
  edCurrentFile.ParentFont = False;
  edCurrentFile.ReadOnly = True;
  edCurrentFile.TabOrder = 5;

  edOtherFile = TEdit.Create(fmDiffCompare);
  edOtherFile.Parent = fmDiffCompare;
  edOtherFile.Left = DefAdjust(96);
  edOtherFile.Top = DefAdjust(48);
  edOtherFile.Width = DefAdjust(385);
  edOtherFile.Height = DefAdjust(23);
  edOtherFile.Anchors = akLeft || akTop || akRight;
  edOtherFile.TabOrder = 0;

  DiffFormOpenDialog = TOpenDialog.Create(fmDiffCompare);

  //fill in fields
  edCurrentFile.Text = Document.FileName;
  if (edCurrentFile.Text == "")
    edCurrentFile.Text = Document.FtpFileName;
  var i;
  var s;
  for (i = 0; i < Documents.Count; i++) {
    s = Documents.Tab[i].FileName;
    if (s == "")
      s = Documents.Tab[i].FtpFileName;
    if ((s != "") && (s[1] != "*" ) && (s != edCurrentFile.Text)) {
      lbFiles.Items.Add(s);
    }
  }
  // select first item
  if (lbFiles.Items.Count > 0) {
    lbFiles.ItemIndex = 0;
    edOtherFile.Text = lbFiles.Items[0];
  }
  // if other item with the same filename exists, select that one
  for (i = 0; i < lbFiles.Items.Count; i++) {
    if (LowerCase(ExtractFileName(lbFiles.Items[i])) == LowerCase(ExtractFileName(edCurrentFile.Text))) {
      lbFiles.ItemIndex = i;
      edOtherFile.Text = lbFiles.Items[i];
      break;
    }
  }

  return fmDiffCompare;
}

function ViewDocumentChanges(Sender) {
  var fname = Document.FileName;
  if (fname == "")
    fname = Document.FtpFileName;
  var i = GetDocumentIndex(fname);
  if (i > -1) {
    lefttext =  document_originals[i];
    leftfileind = -1;
    righttext = Editor.Text;
    rightfileind = i;
    if (lefttext == righttext) {
        alert("Document hasn't changed since opening");
    } else if (Length(righttext) <= MAX_COMPARE_SIZE) {
      LoadBrowser(True, False);
      win.Caption = "History of file " + fname;
    } else {
      alert(fname + " is too big to compare");
    }
  } else {
    //if e.g. Save As was used to rename file
    alert(fname + " doesn't have history");
  }
}

function GetTabByFileNameOrFtpFileName(filename) {
  for (var i = 0; i < Documents.Count; i++) {
    if ((Documents.Tab[i].FileName == filename) || (Documents.Tab[i].FtpFileName == filename)) {
      return Documents.Tab[i];
    }
  }
  return nil;
}

function CompareTo(Sender) {
  CreateDiffForm();
  var res = fmDiffCompare.ShowModal();
  if (res == mrOk) {
    var file1 = edCurrentFile.Text;
    var file2 = edOtherFile.Text;
    leftfileind = GetDocumentIndex(file1);
    rightfileind = GetDocumentIndex(file2);
    var doc1 = GetTabByFileNameOrFtpFileName(file1);
    var doc2 = GetTabByFileNameOrFtpFileName(file2);

    var error = false;

    if (doc1 != nil) {
      lefttext = doc1.Editor.Text;
    } else { //unexpected state
      lefttext = "";
      leftfileind = -1;
      Script.Message("Could not open " + file1);
      error = true;
    }

    //open document that we want to compare to if not open
    if (doc2 == nil) {
      Documents.OpenDocument(file2);
      rightfileind = GetDocumentIndex(file2);
      doc2 = GetTabByFileNameOrFtpFileName(file2);
    }

    if (doc2 != nil) {
      righttext = doc2.Editor.Text;
    } else { //unexpected state
      righttext = "";
      rightfileind = -1;
      Script.Message("Could not open " + file2);
      error = true;
    }

    if (!error) {
      if (lefttext == righttext) {
          alert("Documents are identical");
      } else if ((Length(lefttext) <= MAX_COMPARE_SIZE) && (Length(righttext) <= MAX_COMPARE_SIZE)) {
        LoadBrowser(False, False);
        win.Caption = "Left: " + file1 + " -:- Right: " + file2;
      } else {
        alert("Files are too big to compare");
      }
    }
  }
  delete fmDiffCompare;
  fmDiffCompare = null;
}

function OnWebkitLoadEnd(Sender, Browser, Frame, Status, Res) {
  //workaround: change browser size to work around the issue where mergely doesn't set correct size on initialization
  web.Webkit.Width--;
  web.Webkit.Width++;
}

function OnWebkitConsoleMessage(Sender, browser, message, source, line, Res) {
  Script.Message("Mergely web browser console: " + _t(line) + ":" + source + ":" + message);
}

function SendDocsToMergely() {
  var json = new TScriptableJSON();
  json.SetValue("left", lefttext);
  json.SetValue("right", righttext);
  web.Send("MERGE", json.Stringify());
  delete json;
}

function OnWebkitData(channel, data) {
  var doc;
  var topline;
  var selstart;
  var sel;
  if (channel == DATA_CHANNEL_NAME) {

    if (data == "Ready") {
      SendDocsToMergely();

    } else if (data == "Close") {
      win.Visible = false;

    } else {
      var json = new TScriptableJSON();
      json.parse(data);
      if (json.HasKey("cmd")) {
        var cmd = json.GetValue("cmd");

        if (cmd == "Changes") {
          if (json.HasKey("left") && (leftfileind > -1)) {
            //Script.Message("Left document was changed");
            doc = GetTabByFileNameOrFtpFileName(document_names[leftfileind]);
            if (doc != nil) {
              doc.Editor.BeginEditing;
              topline = doc.Editor.TopLine;
              selstart = doc.Editor.Selection.SelStart;
              doc.Editor.Text = json.GetValue("left");
              sel = doc.Editor.Selection;
              sel.SelStart = selstart;
              sel.SelLength = 0;
              doc.Editor.Selection = sel;
              doc.Editor.TopLine = topline;
              doc.Editor.EndEditing;
            }
          }
          if (json.HasKey("right") && (rightfileind > -1)) {
            //Script.Message("Right document was changed");
            doc = GetTabByFileNameOrFtpFileName(document_names[rightfileind]);
            if (doc != nil) {
              doc.Editor.BeginEditing;
              topline = doc.Editor.TopLine;
              selstart = doc.Editor.Selection.SelStart;
              doc.Editor.Text = json.GetValue("right");
              sel = doc.Editor.Selection;
              sel.SelStart = selstart;
              sel.SelLength = 0;
              doc.Editor.Selection = sel;
              doc.Editor.EndEditing;
              doc.Editor.TopLine = topline;
            }
          }
          win.Visible = false;
        }
      }
      delete json;
    }
  }
}

function GetDocumentIndex(Filename) {
  var r = -1;
  for (var i = 0; i < Length(document_names); i++) {
    if (document_names[i] == Filename) {
      r = i;
      break;
    }
  }
  return r;
}

function RememberOriginalContents(Filename, Text) {
  //just a small sanity check and protection
  if (Length(Text) > MAX_COMPARE_SIZE) {
    Text = "";
  }
  //save document name and contents to arrays
  var i = GetDocumentIndex(Filename);
  if (i > -1) {
    document_originals[i] = Text;
  } else {
    i = Length(document_names);
    SetLength(document_names, i + 1);
    SetLength(document_originals, i + 1);
    document_names[i] = Filename;
    document_originals[i] = Text;
  }
}

function OnDocumentOpen(doc) {
  var fname = Document.FileName;
  if (fname == "")
    fname = Document.FtpFileName;
  RememberOriginalContents(fname, doc.Editor.Text);
}

function OnReady() {
  //what if there were documents open before script was initialized?
  for (var i = 0; i < Documents.Count; i++) {
    var fname = Documents.Tab[i].FileName;
    if (fname == "")
      fname = Documents.Tab[i].FtpFileName;
    RememberOriginalContents(fname, Documents.Tab[i].Editor.Text);
  }
}

function OnInstalled() {
  if (WeBuilder.BuildNumber < 195) {
    return "Newer editor version is required for this plugin to work";
  }
}

function OnExit() {
  delete win;
  win = null;
}

Script.ConnectSignal("exit", &OnExit);
Script.ConnectSignal("ready", &OnReady);
Script.ConnectSignal("document_open", &OnDocumentOpen);
Script.ConnectSignal("installed", &OnInstalled);

Script.RegisterDocumentAction("Diff && Merge", "View Document Changes", "", &ViewDocumentChanges);
Script.RegisterDocumentAction("Diff && Merge", "Compare To...", "", &CompareTo);
